<template>
  <div class="custom-crud-page">
    <el-bus-crud ref="crud" v-bind="crudConfig"></el-bus-crud>
  </div>
</template>

<script>
export default {
  data() {
    return {
      crudConfig: {
        url: 'flower/api/menu/list',
        hasPagination: false,
        saveQuery: false,
        isTree: true,
        hasView: false,
        deleteMessage: () => '此操作将会删除所有子菜单, 是否继续？',
        beforeOpen(row, isNew) {
          if (isNew && row.menuName) {
            row.parentName = row.menuName
          }
          if (!isNew) {
            row.parentName = ''
          }
        },
        extraParentKeys: ['parentName'],
        tableAttrs: {
          rowKey: 'id',
        },
        columns: [
          { label: '菜单名称', prop: 'menuName' },
          {
            label: '前端地址',
            prop: 'menuHref',
          },
          {
            label: '图标',
            formatter: (row) =>
              row.menuIcon ? (
                <i class={row.menuIcon} aria-hidden="true" />
              ) : null,
          },
          { label: '排序', prop: 'seq' },
        ],
        form: [
          {
            label: '父级节点：',
            id: 'parentName',
            type: 'input',
            readonly: true,
            hidden: (row) => !row.parentName,
          },
          {
            label: '标题：',
            id: 'menuName',
            type: 'input',
            el: { placeholder: '请输入标题' },
            rules: { required: true, message: '请输入标题', trigger: 'blur' },
          },
          {
            label: '图标：',
            id: 'menuIcon',
            component: 'base-menu-icon',
          },
          {
            label: '排序：',
            id: 'seq',
            type: 'input-number',
            el: {
              min: 0,
              precision: 0,
              controlsPosition: 'right',
              placeholder: '请输入排序',
            },
          },
          {
            label: '前端地址：',
            id: 'menuHref',
            type: 'input',
            el: { placeholder: '请输入前端地址' },
            rules: {
              required: true,
              message: '请输入前端地址',
              trigger: 'blur',
            },
          },
        ],
      },
    }
  },
  head() {
    return {
      title: '菜单管理',
    }
  },
}
</script>
